/*->c.dc     */

/* Ovation!   (c) D. J. Pilling,  December 1988                     */
/*                        Dictionary Code                             */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "sprite.h"
#include "bbc.h"
#include "werr.h"

#include "deb.h"
#include "etc.h"
#include "wos.h"
#include "err.h"
#include "bf.h"

#include "memblock.h"
#include "reslink.h"
#include "dc.h"





/*****************************************************************************/


#ifdef OLDVERSION


char * mfx[256]=
{
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"abilities", /* 31 */
"ability",
"phobia",
"ities",
"body",
"naut",
"olog",
"able",
"'",        /* ' 39 */
"ally",
"ance",
"edge",
"ance",
"ancy",
"-",        /* - 45 */
"ence",
"ency",
"0",        /* 0 48 */
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
"9",         /* 9 57 */
"hood",
"less",
"like",
"logy",
"ment",
"ness",
"ophy",
"A",         /* A 65 */
"B",
"C",
"D",
"E",
"F",
"G",
"H",
"I",
"J",
"K",
"L",
"M",
"N",
"O",
"P",
"Q",
"R",
"S",
"T",
"U",
"V",
"W",
"X",
"Y",
"Z",
"ship",
"tion",
"ace",
"act",
"age",
"ane",
"a",
"b",
"c",
"d",
"e",
"f",
"g",
"h",
"i",
"j",
"k",
"l",
"m",
"n",
"o",
"p",
"q",
"r",
"s",
"t",
"u",
"v",
"w",
"x",
"y",
"z",       /* z 122 */
"ant",
"ate",
"ent",
"ess",
"ful",
"ian",
"ies",
"ine",
"ing",
"ion",
"ise",
"ish",
"ism",
"ite",
"ity",
"ium",
"ive",
"ize",
"man",
"oid",
"ome",
"ous",
"tic",
"tum",
"ure",
"way",
"al",
"am",
"an",
"ar",
"ch",
"ck",
"de",
"ea",
"ed",
"ee",
"en",
"er",
"es",
"ey",
"gh",
"ic",
"ie",
"in",
"is",
"it",
"le",
"ll",
"ly",
"nd",
"ne",
"nn",
"nt",
"on",
"oo",
"or",
"ph",
"re",
"ry",
"se",
"sh",
"ss",
"te",
"th",
"tt",
"ty",
"um",
"un",
"us",
"",   /* 192 */
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
""};


#else

char * mfx[256]=
{
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"ng",
"ss",
"ess",
"on",
"er",
"ed",
"le",
"ion",
"'",
"te",
"ble",
"al",
"es",
"ce",
"-",
"nt",
"us",
"0",
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
"9",
"tion",
"an",
"ate",
"ic",
"ty",
"ent",
"ies",
"A",
"B",
"C",
"D",
"E",
"F",
"G",
"H",
"I",
"J",
"K",
"L",
"M",
"N",
"O",
"P",
"Q",
"R",
"S",
"T",
"U",
"V",
"W",
"X",
"Y",
"Z",
"se",
"able",
"ne",
"ation",
"re",
"nce",
"a",
"b",
"c",
"d",
"e",
"f",
"g",
"h",
"i",
"j",
"k",
"l",
"m",
"n",
"o",
"p",
"q",
"r",
"s",
"t",
"u",
"v",
"w",
"x",
"y",
"z",
"st",
"ing",
"ous",
"ge",
"de",
"ly",
"nd",
"ity",
"rd",
"ck",
"sm",
"ry",
"sh",
"en",
"ar",
"ia",
"in",
"ter",
"ul",
"ted",
"lity",
"ch",
"ility",
"bility",
"ard",
"lly",
"ence",
"is",
"et",
"ve",
"um",
"ct",
"ance",
"me",
"ine",
"ht",
"ay",
"tic",
"ad",
"ll",
"ian",
"ip",
"cal",
"ght",
"el",
"and",
"ries",
"ication",
"ant",
"cy",
"age",
"at",
"th",
"ial",
"ious",
"id",
"ke",
"ire",
"one",
"ish",
"ive",
"logy",
"ness",
"ogical",
"il",
"own",
"ties",
"it",
"ue",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
};


#endif





#define NMIDFIX sizeof(mfx) / sizeof(char *)




typedef struct chardatastr
{
 char rank;
 char upper;
 char lower;
 char upperrank;
 char lowerrank;
 unsigned short bits;

} chardatastr;


static chardatastr chardata[256]=
{
  0,  0,  0,  0,  0,0x4   , //      
  1,  1,  1,  1,  1,0x4   , //      
  2,  2,  2,  2,  2,0x4   , //      
  3,  3,  3,  3,  3,0x4   , //      
  4,  4,  4,  4,  4,0x4   , //      
  5,  5,  5,  5,  5,0x4   , //      
  6,  6,  6,  6,  6,0x4   , //      
  7,  7,  7,  7,  7,0x4   , //      
  8,  8,  8,  8,  8,0x4   , //      
 43,  9,  9, 43, 43,0x284 , //      
 44, 10, 10, 44, 44,0x204 , //      
 45, 11, 11, 45, 45,0x204 , //      
 46, 12, 12, 46, 46,0x204 , //      
 47, 13, 13, 47, 47,0x204 , //      
  9, 14, 14,  9,  9,0x4   , //      
 10, 15, 15, 10, 10,0x4   , //      
 11, 16, 16, 11, 11,0x4   , //      
 12, 17, 17, 12, 12,0x4   , //      
 13, 18, 18, 13, 13,0x4   , //      
 14, 19, 19, 14, 14,0x4   , //      
 15, 20, 20, 15, 15,0x4   , //      
 16, 21, 21, 16, 16,0x4   , //      
 17, 22, 22, 17, 17,0x4   , //      
 18, 23, 23, 18, 18,0x4   , //      
 19, 24, 24, 19, 19,0x4   , //      
 20, 25, 25, 20, 20,0x4   , //      
 21, 26, 26, 21, 21,0x4   , //      
 22, 27, 27, 22, 22,0x4   , //      
 23, 28, 28, 23, 23,0x4   , //      
 24, 29, 29, 24, 24,0x4   , //      
 25, 30, 30, 25, 25,0x4   , //      
 26, 31, 31, 26, 26,0x4   , //      
 41, 32, 32, 41, 41,0x280 , //      
 48, 33, 33, 48, 48,0x190 , // ! ! !
 49, 34, 34, 49, 49,0x190 , // " " "
 50, 35, 35, 50, 50,0x190 , // # # #
 51, 36, 36, 51, 51,0x190 , // $ $ $
 52, 37, 37, 52, 52,0x190 , // % % %
 53, 38, 38, 53, 53,0x190 , // & & &
 36, 39, 39, 36, 36,0x190 , // ' ' '
 54, 40, 40, 54, 54,0x190 , // ( ( (
 55, 41, 41, 55, 55,0x190 , // ) ) )
 56, 42, 42, 56, 56,0x190 , // * * *
 91, 43, 43, 91, 91,0x190 , // + + +
 57, 44, 44, 57, 57,0x190 , // , , ,
 37, 45, 45, 37, 37,0x190 , // - - -
 58, 46, 46, 58, 58,0x190 , // . . .
 59, 47, 47, 59, 59,0x190 , // / / /
117, 48, 48,117,117,0x9a  , // 0 0 0
121, 49, 49,121,121,0x9a  , // 1 1 1
123, 50, 50,123,123,0x9a  , // 2 2 2
125, 51, 51,125,125,0x9a  , // 3 3 3
127, 52, 52,127,127,0x9a  , // 4 4 4
128, 53, 53,128,128,0x9a  , // 5 5 5
129, 54, 54,129,129,0x9a  , // 6 6 6
130, 55, 55,130,130,0x9a  , // 7 7 7
131, 56, 56,131,131,0x9a  , // 8 8 8
132, 57, 57,132,132,0x9a  , // 9 9 9
 60, 58, 58, 60, 60,0x190 , // : : :
 61, 59, 59, 61, 61,0x190 , // ; ; ;
 92, 60, 60, 92, 92,0x190 , // < < <
 93, 61, 61, 93, 93,0x190 , // = = =
 94, 62, 62, 94, 94,0x190 , // > > >
 62, 63, 63, 62, 62,0x190 , // ? ? ?
 63, 64, 64, 63, 63,0x190 , // @ @ @
134, 65, 97,134,133,0xd3  , // A A a
151, 66, 98,151,150,0xd3  , // B B b
153, 67, 99,153,152,0xd3  , // C C c
157, 68,100,157,156,0xd3  , // D D d
161, 69,101,161,160,0xd3  , // E E e
171, 70,102,171,170,0xd3  , // F F f
174, 71,103,174,173,0xd3  , // G G g
176, 72,104,176,175,0xd3  , // H H h
178, 73,105,178,177,0xd3  , // I I i
188, 74,106,188,187,0xd3  , // J J j
190, 75,107,190,189,0xd3  , // K K k
192, 76,108,192,191,0xd3  , // L L l
194, 77,109,194,193,0xd3  , // M M m
196, 78,110,196,195,0xd3  , // N N n
200, 79,111,200,199,0xd3  , // O O o
217, 80,112,217,216,0xd3  , // P P p
219, 81,113,219,218,0xd3  , // Q Q q
221, 82,114,221,220,0xd3  , // R R r
223, 83,115,223,222,0xd3  , // S S s
228, 84,116,228,227,0xd3  , // T T t
233, 85,117,233,232,0xd3  , // U U u
243, 86,118,243,242,0xd3  , // V V v
245, 87,119,245,244,0xd3  , // W W w
247, 88,120,247,246,0xd3  , // X X x
249, 89,121,249,248,0xd3  , // Y Y y
255, 90,122,255,254,0xd3  , // Z Z z
 64, 91, 91, 64, 64,0x190 , // [ [ [
 65, 92, 92, 65, 65,0x190 , // \ \ \  continuation char
 66, 93, 93, 66, 66,0x190 , // ] ] ]
 67, 94, 94, 67, 67,0x190 , // ^ ^ ^
 69, 95, 95, 69, 69,0x190 , // _ _ _
 70, 96, 96, 70, 70,0x190 , // ` ` `
133, 65, 97,134,133,0xb3  , // a A a
150, 66, 98,151,150,0xb3  , // b B b
152, 67, 99,153,152,0xb3  , // c C c
156, 68,100,157,156,0xb3  , // d D d
160, 69,101,161,160,0xb3  , // e E e
170, 70,102,171,170,0xb3  , // f F f
173, 71,103,174,173,0xb3  , // g G g
175, 72,104,176,175,0xb3  , // h H h
177, 73,105,178,177,0xb3  , // i I i
187, 74,106,188,187,0xb3  , // j J j
189, 75,107,190,189,0xb3  , // k K k
191, 76,108,192,191,0xb3  , // l L l
193, 77,109,194,193,0xb3  , // m M m
195, 78,110,196,195,0xb3  , // n N n
199, 79,111,200,199,0xb3  , // o O o
216, 80,112,217,216,0xb3  , // p P p
218, 81,113,219,218,0xb3  , // q Q q
220, 82,114,221,220,0xb3  , // r R r
222, 83,115,223,222,0xb3  , // s S s
227, 84,116,228,227,0xb3  , // t T t
232, 85,117,233,232,0xb3  , // u U u
242, 86,118,243,242,0xb3  , // v V v
244, 87,119,245,244,0xb3  , // w W w
246, 88,120,247,246,0xb3  , // x X x
248, 89,121,249,248,0xb3  , // y Y y
254, 90,122,255,254,0xb3  , // z Z z
 71,123,123, 71, 71,0x190 , // { { {
 72,124,124, 72, 72,0x190 , // | | |
 73,125,125, 73, 73,0x190 , // } } }
 74,126,126, 74, 74,0x190 , // ~ ~ ~
 27,127,127, 27, 27,0x4   , //      
 28,128,128, 28, 28,0x4   , //      
 29,129,129, 29, 29,0x4   , //      
 85,130,130, 85, 85,0x190 , //   
172,131,131,172,172,0x1b3 , //   
 88,132,132, 88, 88,0x190 , //   
115,133,133,115,115,0x190 , //   
112,134,134,112,112,0x190 , //   
113,135,135,113,113,0x190 , //   
 68,136,136, 68, 68,0x190 , //   
116,137,137,116,116,0x190 , //   
225,138,154,225,224,0xd3  , //   
 89,139,139, 89, 89,0x190 , //   
215,140,156,215,214,0xd3  , //   
 30,141,141, 30, 30,0x4   , //      
 31,142,142, 31, 31,0x4   , //      
 32,143,143, 32, 32,0x4   , //      
 33,144,144, 33, 33,0x4   , //      
 83,145,145, 83, 83,0x190 , //   
 84,146,146, 84, 84,0x190 , //   
 86,147,147, 86, 86,0x190 , //   
 87,148,148, 87, 87,0x190 , //   
114,149,149,114,114,0x190 , //   
 39,150,150, 39, 39,0x190 , //   
 40,151,151, 40, 40,0x190 , //   
 82,152,152, 82, 82,0x190 , //   
231,153,153,231,231,0x190 , //   
224,138,154,225,224,0xb3  , //   
 90,155,155, 90, 90,0x190 , //   
214,140,156,215,214,0xb3  , //   
 34,157,157, 34, 34,0x4   , //      
 35,158,158, 35, 35,0x4   , //      
253,159,255,253,252,0xd3  , //   
 42,160,160, 42, 42,0x280 , //   
 75,161,161, 75, 75,0x190 , //   
100,162,162,100,100,0x190 , //   
101,163,163,101,101,0x190 , //   
102,164,164,102,102,0x190 , //   
103,165,165,103,103,0x190 , //   
 76,166,166, 76, 76,0x190 , //   
104,167,167,104,104,0x190 , //   
 77,168,168, 77, 77,0x190 , //   
105,169,169,105,105,0x190 , //   
135,170,170,135,135,0x190 , //   
 96,171,171, 96, 96,0x190 , //   
106,172,172,106,106,0x190 , //   
 38,173,173, 38, 38,0x190 , //   
107,174,174,107,107,0x190 , //   
 78,175,175, 78, 78,0x190 , //   
108,176,176,108,108,0x190 , //   
 95,177,177, 95, 95,0x190 , //   
124,178,178,124,124,0x19a , //   
126,179,179,126,126,0x19a , //   
 79,180,180, 79, 79,0x190 , //   
109,181,181,109,109,0x190 , //   
110,182,182,110,110,0x190 , //   
111,183,183,111,111,0x190 , //   
 80,184,184, 80, 80,0x190 , //   
122,185,185,122,122,0x19a , //   
201,186,186,201,201,0x190 , //   
 97,187,187, 97, 97,0x190 , //   
118,188,188,118,118,0x190 , //   
119,189,189,119,119,0x190 , //   
120,190,190,120,120,0x190 , //   
 81,191,191, 81, 81,0x190 , //   
139,192,224,139,138,0xd3  , //   
137,193,225,137,136,0xd3  , //   
141,194,226,141,140,0xd3  , //   
145,195,227,145,144,0xd3  , //   
143,196,228,143,142,0xd3  , //   
147,197,229,147,146,0xd3  , //   
149,198,230,149,148,0xd3  , //   
155,199,231,155,154,0xd3  , //   
165,200,232,165,164,0xd3  , //   
163,201,233,163,162,0xd3  , //   
167,202,234,167,166,0xd3  , //   
169,203,235,169,168,0xd3  , //   
182,204,236,182,181,0xd3  , //   
180,205,237,180,179,0xd3  , //   
184,206,238,184,183,0xd3  , //   
186,207,239,186,185,0xd3  , //   
159,208,240,159,158,0xd3  , //   
198,209,241,198,197,0xd3  , //   
205,210,242,205,204,0xd3  , //   
203,211,243,203,202,0xd3  , //   
207,212,244,207,206,0xd3  , //   
211,213,245,211,210,0xd3  , //   
209,214,246,209,208,0xd3  , //   
 98,215,215, 98, 98,0x190 , //   
213,216,248,213,212,0xd3  , //   
237,217,249,237,236,0xd3  , //   
235,218,250,235,234,0xd3  , //   
239,219,251,239,238,0xd3  , //   
241,220,252,241,240,0xd3  , //   
251,221,253,251,250,0xd3  , //   
230,222,254,230,229,0xd3  , //   
226,223,223,226,226,0xb3  , //   
138,192,224,139,138,0xb3  , //   
136,193,225,137,136,0xb3  , //   
140,194,226,141,140,0xb3  , //   
144,195,227,145,144,0xb3  , //   
142,196,228,143,142,0xb3  , //   
146,197,229,147,146,0xb3  , //   
148,198,230,149,148,0xb3  , //   
154,199,231,155,154,0xb3  , //   
164,200,232,165,164,0xb3  , //   
162,201,233,163,162,0xb3  , //   
166,202,234,167,166,0xb3  , //   
168,203,235,169,168,0xb3  , //   
181,204,236,182,181,0xb3  , //   
179,205,237,180,179,0xb3  , //   
183,206,238,184,183,0xb3  , //   
185,207,239,186,185,0xb3  , //   
158,208,240,159,158,0xb3  , //   
197,209,241,198,197,0xb3  , //   
204,210,242,205,204,0xb3  , //   
202,211,243,203,202,0xb3  , //   
206,212,244,207,206,0xb3  , //   
210,213,245,211,210,0xb3  , //   
208,214,246,209,208,0xb3  , //   
 99,247,247, 99, 99,0x190 , //   
212,216,248,213,212,0xb3  , //   
236,217,249,237,236,0xb3  , //   
234,218,250,235,234,0xb3  , //   
238,219,251,239,238,0xb3  , //   
240,220,252,241,240,0xb3  , //   
250,221,253,251,250,0xb3  , //   
229,222,254,230,229,0xb3  , //   
252,159,255,253,252,0xb3  , //   


};



/*
 xstrncmp(char * s1,char * s2,int max,int flags);
;             a1         a2       a3       a4
;
; flags    input   0x10000 ignore hyphens
;          output  0x1     case mismatch

*/

int xstrncmp(char * first,char * second,int n,int * flags)
{
 int f=0;
 int s=0;
 int code;
 int code1;
 int casematch;
 int hyphens;
 int space;

 *flags=(*flags) & 0xFF0000;
 hyphens=(*flags) & 0x10000;
 space=(*flags) & 0x20000;
 casematch=0;

 while(n--)
 {
  if(hyphens)
  {
   while(1)
   {
    f=*first++;
    if(f!='-') break;
   }

   while(1)
   {
    s=*second++;
    if(s!='-') break;
   }
  }
  else
  if(space)
  {
   while(1)
   {
    f=*first++;
    if(f!=' ') break;
   }

   while(1)
   {
    s=*second++;
    if(s!=' ') break;
   }
  }
  else
  {
   f=*first++;
   s=*second++;
  }
  code1=(chardata[f].rank-chardata[s].rank);
  if(code1)
  {
   code=(chardata[f].upperrank-chardata[s].upperrank);
   if(code) return(code1);
   if(casematch==0)
   {
    if(code1<0) casematch=0x1;
    else        casematch=0x3;
   }
  }

  if(f==0) break;
 }

 *flags=(*flags)|(casematch);

 return(0);
}




static char workstring[STRMAX];
static char * workptr;

int xgetscanstring(char * string)
{
 strcpy(string,workstring);
 return(((int)workptr)-1);
}



int xscanword(char * string,int * flags,char * subs,char * dcspc)
{
 int    copyup;
 char * match;
 int    matchlen;
 int    capslen;
 int    dohyphen;
 int    token=0;
 char * p;
 char * q;
 char * r;
 char * w;
 int    f;
 int    s=0;
 int    code=0;


 *flags=(*flags) & 0xFF0000;
 dohyphen=(*flags) & 0x10000;

 copyup=*dcspc++;
 match=workstring;

 memcpy(workstring,subs,copyup);
 *(workstring+copyup)=0;

 matchlen=0;
 capslen=0;
 p=workstring;
 q=string;

 if(copyup) goto startmatch;

 while(1)                   // start new word
 {
  while(copyup>matchlen)
  {                         // skip to next word
   while(1)
   {
    copyup=*dcspc++;
    if(copyup==ESCTOK) dcspc++;
    else
    if(copyup<ESCTOK) break;
   }
  }

  matchlen=copyup;
  if(capslen>matchlen) capslen=matchlen;  // make sure cap match less equal match
  p=workstring+matchlen;
  q=string+matchlen;

  if(dohyphen)
  {
    // count hyphens in workstring 
   if(matchlen>0)
   {
    r=workstring;
    while(r<p)
    {
     if((*r++)=='-') q--;
    }
   }
  }


  token=*dcspc++;
  while(1)                      // move through tokens loop
  {
   if(token==0) goto finished;
   if(token==ESCTOK)
   {
    *p=*dcspc++;
    copyup++;
    *(p+1)=0;
   }
   else
   {
    r=mfx[token];
    w=p;
    while(1)
    {
     if(*r==0) break;
     *w++=*r++;
     copyup++;
    }
    *w=0;
   }

startmatch:

   while(1)                    // match loop
   {
    f=*p++;

    if(dohyphen && f=='-')
    {
     code=0;
    }
    else
    {
     s=*q++;
     code=(chardata[f].rank-chardata[s].rank);
    }

    if(code==0)
    {
     if(capslen>=matchlen) capslen++;
     matchlen++;
    }
    else
    {
     if((chardata[f].upperrank-chardata[s].upperrank)==0)
     {
      code=0;
      matchlen++;
     }
     else
     if(code<0)
     {  // skip word

      break;
     }
     else
     { // its all over

      if(dohyphen && (matchlen>(q-string-1)))
      {
       code=-1;
       break;
      }
      else
      {
       return(0);
      }
     }
    }

    // assert code==0 here

    if(matchlen>=copyup)
    {
     token=*dcspc++;

     if(token<ESCTOK)
     {
      if(*q==0)      // a hit
      {
       // set flags and workptr
       if(capslen!=matchlen) *flags=(*flags) | 0x1;
       workptr=dcspc;

       return(1);
      }
      else           // start new word
      {
       copyup=token;
       code=-1;      // force outer loop
       break;
      }
     }
     else
     {
                    // leave compare loop and get the next token
      break;
     }
    }
   }

   if(code<0) break;
  }
 }

finished:

 return(0); // word not found
}




/*****************************************************************************/


/* make a change to the word string space */

os_error * changeword(dict * dp,char * code,int woffset,int newlen,int oldlen)
{
 os_error * err;
 char     * c;
 int        i;

 
 err=alterblock(&dp->words,woffset,newlen-oldlen);
 if(!err)
 {
 // formblock(dp->words,0,SIZEBUFF(dp->words));
  c=charblock(dp->words,woffset);
  for(i=0;i<newlen;i++) *c++=code[i];
 }

 return(err);
}



/* insert a new index pointer at indexn */

os_error * insindex(dict * dp,int indexn,index ** indexp)
{
 os_error * err;
 
 err=alterblock(&dp->index,indexn*sizeof(index),sizeof(index));
 if(!err)
 {
 // formblock(dp->index,0,SIZEBUFF(dp->index));
  dp->noindex++;
  *indexp=((index *)charblock(dp->index,indexn*sizeof(index)));
 }
 return(err);
}




os_error * delindex(dict * dp,int indexn)
{
 os_error * err;
 
 err=alterblock(&dp->index,indexn*sizeof(index),-(int)sizeof(index));
 if(!err)
 {
 // formblock(dp->index,0,SIZEBUFF(dp->index));
  dp->noindex--;
 }

 return(err);
}





#define SPLIT 12

int lolim[SPLIT]={31,40,46,58,91,123,39,45,48,65,97 ,192};
int hilim[SPLIT]={39,45,49,65,97,192,40,46,58,91,123,256};

int codeword(char * prev,char * word,char *  code)
{
 int i=0;
 int j=0;
 int k=0;
 int l;
 int w=0;

 while(prev[i] && word[i] && prev[i]==word[i]) i++;

 *(code+w)=(char)i;
 w++;
 if(!word[i]) return(w);

 word+=i;

 while(1)
 {
  if(w>=STRLEN) return(0);

  for(l=0;l<SPLIT;l++)                   /* looking for end of word */
  {
   for(j=lolim[l];j<hilim[l];j++)
   {
    if(!strcmp(word,mfx[j]))
    {
     *(code+w)=(char)j;
     w++;
     return(w);
    }
   }
  }

  for(l=0;l<SPLIT;l++)                   /* looking for mid strings */
  {
   for(j=lolim[l];j<hilim[l];j++)
   {
    k=0;
    while(mfx[j][k])
     {
      if(mfx[j][k]!=word[k]) break; 
      else                   k++;
     }
    if(!mfx[j][k] && word[k]) break;
   }
   if(j<hilim[l]) break;
  }

  if(l==SPLIT)
  {
   *(code+w)=ESCTOK;
   w++;
   *(code+w)=*word++;
   w++;
   if(!*word) return(w);
   /*return(0); */
  }
  else
  {
   *(code+w)=(char)j;
   w++;
   word+=k;
  }
 }
}



int formword(dict * dp,word * words)
{
 char * c;
 int    n;
 int    m;

 c=charblock(dp->words,words->woffset);
 n=(*c) & 0x1F;
 words->string[n]=0;

 n=0;
 while(1)
 {
  c++;
  n++;
  if((*c)<MINTOK)
  {
   if(*c==ESCTOK)
   {
    m=strlen(words->string);
    c++;
    n++;
    words->string[m++]=*c;
    words->string[m]=0;
   }
   else
   {
    break;
   }
  }
  else
  {
   strcat(words->string,mfx[*c]);
  }
 }

 words->len=n;
 return(1);
}





/* given one words structure, step to the next one */
/* return 0 if no more                             */

int nextword(dict * dp,word * words)
{
 char * c;
 int             n;
 int             offset;
 int             m;

 words->woffset+=words->len;

 words->wordn++;
 if(words->wordn>=dp->nowords)
 {
  words->len=0;
  strcpy(words->string,"");
  return(0);
 }

 offset=words->woffset;

 c=charblock(dp->words,offset);
 n=(*c) & 0x1F;
 words->string[n]=0;

 n=0;
 while(1)
 {
  c++;
  n++;
  if((*c)<MINTOK)
  {
   if(*c==ESCTOK)
   {
    m=strlen(words->string);
    c++;
    n++;
    words->string[m++]=*c;
    words->string[m]=0;
   }
   else
   {
    break;
   }
  } 
  else
  {
   strcat(words->string,mfx[*c]);
  }
 }

 words->len=n;

 return(1);
}


/***************************************************************************/

/*

void printindexs(dict *dp)
{
 int     indexn;
 index * indexp;
 char    string[16];

 for(indexn=dp->noindex-1;indexn<dp->noindex;indexn++)
 {
  indexp=(index*)charblock(dp->index,indexn*sizeof(index));

  strncpy(string,indexp->key,KEYLEN);
  string[KEYLEN+1]=0;
 }

}


 */


/* check if index is OK, return 1, else remove index and return 0 */

static int validindex(dict * dp,unsigned int indexn,word * words)
{
 unsigned int    maxwordn;
 int    change=0;
 char * c;
 int    n=0;

 index * indexp=(index*)charblock(dp->index,indexn*sizeof(index));


/*  dprintf(1,"validindex enter ");   */


 if((indexn+1)<dp->noindex) 
     maxwordn=WORDN((index*)charblock(dp->index,(indexn+1)*sizeof(index)));
 else
     maxwordn=dp->nowords;

 while((words->wordn)<maxwordn)
 {
  c=charblock(dp->words,words->woffset);
  n=(*c) & 0x1F;
  if(n<KEYLEN) break;
  change=1;
  nextword(dp,words);
 }

/* dprintf(1,"validindex change=%d",change); */


 if(n<KEYLEN && change)
 {
  SETWORDN(indexp,words->wordn);
  SETWOFF(indexp,words->woffset);
  strncpy(indexp->key,words->string,KEYLEN);
  return(1);
 }
 else
 if(change)
 {
  delindex(dp,indexn);
  return(0);
 }

 return(1);
}



void setindx(int index1,index ** indexp0,index ** indexp1,index ** indexp2,
                                                                dict * dp)
{
 int index0;
 int index2;

 index0=index1-1;
 index2=index1+1;

 if(index0>=0) *indexp0=(index *)charblock(dp->index,index0*sizeof(index));
 else          *indexp0=NULL;

 *indexp1=(index *)charblock(dp->index,index1*sizeof(index));

 if(index2<(int)dp->noindex) 
               *indexp2=(index *)charblock(dp->index,index2*sizeof(index));
 else          *indexp2=NULL;

}


/* given words structure, remove from dictionary */

int remword(dict * dp,word * words)
{
 word    nextwords;
 word    prevwords;

 int     index0;
 int     index1;
 int     index2;

 index * indexp0;
 index * indexp1;
 index * indexp2;

 char    code[STRLEN];
 int     shift;
 int     indexn;
 int     indexc;
 index * indexp;
 index * f;

 int     tempwoffset;
 int     tempwordn;
 int     len;
 int     maxindex=dp->noindex;

 int     delcurindex=0;
 int     nextindex=0;
 int     curvalid=1;

 int     wn;


 /* accepting that due to error in findword, may get index one too small */

 while(1)
 {
  index1=words->indexn;
  index1++;
  if(index1>=maxindex) break;
  indexp1=(index *)charblock(dp->index,index1*sizeof(index));
  if(words->wordn<WORDN(indexp1)) break;
  words->indexn=words->indexn+1;
 }

 index1=words->indexn;
 index0=index1-1;
 index2=index1+1;


 setindx(index1,&indexp0,&indexp1,&indexp2,dp);

 if(dp->nowords==1)    /* only one word in dictionary */
 {
  setsizeblock(&dp->words,0);
  setsizeblock(&dp->index,0);
  dp->nowords=0;
  dp->noindex=0;
 }
 else
 if(words->wordn==(dp->nowords-1))  /* deleting last word */
 {
  if(words->wordn==WORDN(indexp1)) delindex(dp,index1);
  changeword(dp,NULL,words->woffset,0,words->len);
  dp->nowords--;
 }
 else
 if(!words->wordn)                  /* deleting first word */
 {
  nextwords=*words;
  nextword(dp,&nextwords);
  len=codeword("",nextwords.string,code);
  strncpy(indexp1->key,nextwords.string,KEYLEN);
  shift=len-words->len-nextwords.len;
  changeword(dp,code,words->woffset,len,words->len+nextwords.len);
  dp->nowords--;

  indexn=index1;
  indexc=indexn*sizeof(index);
  while(++indexn<maxindex)
  {
   indexc+=sizeof(index);
   indexp=(index *)charblock(dp->index,indexc);
   tempwoffset=WOFF(indexp)+shift;
   tempwordn=WORDN(indexp)-1;
   SETWORDN(indexp,tempwordn);
   SETWOFF(indexp,tempwoffset);
  }

 }
 else                              /* deleting word in middle */
 {
  nextwords=*words;
  nextword(dp,&nextwords);

  delcurindex=words->wordn==WORDN(indexp1);
  nextindex=indexp2 && (nextwords.wordn==WORDN(indexp2));

  cprintf("delcurindex=%d nextindex=%d",delcurindex,nextindex); 
  cprintf("wordn=%d WORDN=%d string=%s",words->wordn,WORDN(indexp1),
                                        words->string);

  if(words->wordn>WORDN(indexp1))
  {
   f=indexp1;
   prevwords.indexn=index1;
  }
  else
  {
   f=indexp0;
   prevwords.indexn=index0;
  }

  strncpy(prevwords.string,f->key,KEYLEN);
  prevwords.woffset=WOFF(f);
  prevwords.wordn=WORDN(f);
  prevwords.len=0;

  formword(dp,&prevwords);

  while(prevwords.wordn<(words->wordn-1)) nextword(dp,&prevwords);

  cprintf("prev=%s next=%s",prevwords.string,nextwords.string);

  len=codeword(prevwords.string,nextwords.string,code);
  nextwords.woffset-=words->len;
  nextwords.wordn-=1;
  shift=len-words->len-nextwords.len;
  changeword(dp,code,words->woffset,len,words->len+nextwords.len);
  nextwords.len=len;
  dp->nowords--;

  setindx(index1,&indexp0,&indexp1,&indexp2,dp);

  if(delcurindex)
  {
   strncpy(indexp1->key,nextwords.string,KEYLEN);
  }

  if(nextindex)
  {
   tempwoffset=WOFF(indexp2)-words->len;
   tempwordn=WORDN(indexp2)-1;
   SETWORDN(indexp2,tempwordn);
   SETWOFF(indexp2,tempwoffset);
   indexn=index2;
  }
  else
  {
   indexn=index1;
  }

  indexc=indexn*sizeof(index);
  while(++indexn<maxindex)
  {
   indexc+=sizeof(index);
   indexp=(index *)charblock(dp->index,indexc);
   tempwoffset=WOFF(indexp)+shift;
   tempwordn=WORDN(indexp)-1;
   SETWORDN(indexp,tempwordn);
   SETWOFF(indexp,tempwoffset);
  }

  if(delcurindex) curvalid=validindex(dp,index1,&nextwords);
 }


 if(dp->nowords && curvalid && dp->noindex>1 && index1>0)
 {
  /* merge indexes */
  /* we know word has been chopped out of index1 */

  setindx(index1,&indexp0,&indexp1,&indexp2,dp);
 
  wn=WORDN(indexp1)-WORDN(indexp0);
  if(wn<64) 
  {
   delindex(dp,index1);
  }
  else
  if(index2<(int)dp->noindex)
  {
   wn=WORDN(indexp2)-WORDN(indexp1);
   if(wn<64) delindex(dp,index1);
  }
  else
  {
   wn=dp->nowords-WORDN(indexp1);
   if(wn<64) delindex(dp,index1);
  }

 }

 return(1);
}



void splitindex(dict * dp,int indexn,int count)
{
 word words;
 index * indexp;
 char * c;
 int    n=KEYLEN;                  /* probably needed */
 int    maxwordn;
 int    startn;


 indexp=(index*)charblock(dp->index,indexn*sizeof(index));

 strncpy(words.string,indexp->key,KEYLEN);
 words.woffset=WOFF(indexp);
 words.indexn=indexn;
 words.wordn=WORDN(indexp);
 words.len=0;
 formword(dp,&words);


 maxwordn=WORDN(indexp)+count;
 startn=WORDN(indexp)+count/2;

/* dprintf(1,"split index word=%s maxwordn=%d startn=%d",
                                   words.string,maxwordn,startn); */


 while(words.wordn<(unsigned int)startn) nextword(dp,&words);

 while(words.wordn<(unsigned int)maxwordn)
 {
  c=charblock(dp->words,words.woffset);
  n=(*c) & 0x1F;
  if(n<KEYLEN) break;
  nextword(dp,&words);
 }

 if(n<KEYLEN)
 {
  insindex(dp,indexn+1,&indexp);
  SETWORDN(indexp,words.wordn);
  SETWOFF(indexp,words.woffset);
  strncpy(indexp->key,words.string,KEYLEN);

 /* dprintf(2,"split index word=%s ",words.string); */
 }

}





/* add words structure to dictionary             */


os_error * storeword(char * string,dict * dp,word * words)
{
 os_error * err;
 char       code[STRLEN];
 int        len;
 int        oldnxlen;
 index    * indexp;
 word       nextwords;
 int        isnext;
 int        val;
 int        indexn;
 int        indexbase;
 int        indexc;
 int        maxindex;
 int        shift=0;

 int        count;

 int        tempwoffset;
 int        tempwordn;

 int        flags=0;

 int        checkvalid=0;

 int        index1;
 index    * indexp1;


 err=NULL;

 maxindex=dp->noindex;

 /* accepting that due to error in findword, may get index one too small */

 while(1)
 {
  index1=words->indexn;
  index1++;
  if(index1>=maxindex) break;
  indexp1=(index *)charblock(dp->index,index1*sizeof(index));
  if(words->wordn<WORDN(indexp1)) break;
  words->indexn=words->indexn+1;
 }


 if(!dp->nowords)
 {
  len=codeword("",string,code);
  if(!len) return(0);
  code[len++]=0;
  code[len++]=0;

//  n=alterbuffer(dp->words,0,2*STRLEN);
//  alterbuffer(dp->words,0,-2*STRLEN);
//  if(n<(2*STRLEN)) return(0);

  err=changeword(dp,code,0,len,0);
  if(!err)
  {
   err=insindex(dp,0,&indexp);
   if(!err)
   {
    SETWOFF(indexp,0);
    SETWORDN(indexp,0);
    strncpy(indexp->key,string,KEYLEN);
   }
  }

  dp->nowords++;
 }
 else
 {
  indexbase=indexn=words->indexn;
  indexc=indexn*sizeof(index);
  maxindex=dp->noindex;

  val=xstrncmp(string,words->string,STRMAX,&flags);
  nextwords=*words;

//  n=alterbuffer(dp->words,nextwords.woffset,2*STRLEN);
//  alterbuffer(dp->words,nextwords.woffset,-2*STRLEN);
//  if(n<(2*STRLEN)) return(0);


  if(val>0)
  {
   len=codeword(words->string,string,code);
   if(!len) return(0);
   isnext=nextword(dp,&nextwords);
  }
  else
  {                        /* there wasn't a smaller word - so must be first */
   len=codeword("",string,code);
   if(!len) return(0);
   indexp=(index *)charblock(dp->index,indexc);
   strncpy(indexp->key,string,KEYLEN);
   isnext=1;
  }

  err=changeword(dp,code,nextwords.woffset,len,0);
  if(!err)
  {
   shift=len;

   if(isnext)
   {
    nextwords.woffset+=len;
    len=codeword(string,nextwords.string,code);
    changeword(dp,code,nextwords.woffset,len,nextwords.len);
    oldnxlen=nextwords.len;
    nextwords.len=len;

   /* dprintf(5,"nextwords->string=%s",nextwords.string); */

    if((indexn+1)<maxindex)
    {
     indexp=(index *)charblock(dp->index,indexc+sizeof(index));

  /*  dprintf(4,"WORDN(indexp)=%d word=%d",WORDN(indexp),nextwords.wordn); */

     if(WORDN(indexp)==nextwords.wordn)
     {
      indexn++;
      indexc+=sizeof(index);
      tempwoffset=WOFF(indexp)+shift;
      tempwordn=WORDN(indexp)+1;
      SETWORDN(indexp,tempwordn);
      SETWOFF(indexp,tempwoffset);
      checkvalid=indexn;
/*     indexn++;
      indexc+=sizeof(index);  */  /* because loop below preincrements */
     }
    }
    nextwords.wordn++;
    shift+=len-oldnxlen;
   }
  }


  if(!err)
  {
   while(++indexn<maxindex)
   {
    indexc+=sizeof(index);
    indexp=(index *)charblock(dp->index,indexc);
    tempwoffset=WOFF(indexp)+shift;
    tempwordn=WORDN(indexp)+1;
    SETWORDN(indexp,tempwordn);
    SETWOFF(indexp,tempwoffset);
   }

   if(checkvalid) validindex(dp,checkvalid,&nextwords);

   indexn=indexbase;
   indexc=indexn*sizeof(index);
   indexp=(index *)charblock(dp->index,indexc);
   count=WORDN(indexp);

   if(++indexn<maxindex)
   {
    indexc+=sizeof(index);
    indexp=(index *)charblock(dp->index,indexc);
    count=WORDN(indexp)-count;
   }
   else
   {
    count=dp->nowords-count;
   }
  
   if(count>=128)
   {
    splitindex(dp,indexbase,count);
   }
  }

  dp->nowords++;
 }

 return(err);
}





/* returns 1 if word found or 0 if not found     */
/* returns previous word structure in dictionary */
/* flags 0x10000 == ignore hyphens               */
/*       0x20000 == fast search return no data   */

int findword(char * string,dict * dp,word * words,int * flags)
{
 int         n=dp->noindex;
 int         lo=0;
 int         hi=(n-1)*sizeof(index);
 int         i=0;
 int         loi=0;
 int         hii=n-1;
 int         ii=0;
 int         code=0;
 index    *  f=NULL;
 char     *  p;
 word        oldwords;

 if(!dp->nowords)
 {
  words->woffset=0;
  words->indexn=0;
  strcpy(words->string,"");
  words->wordn=0;
  words->len=0;
 }
 else
 {
  p=charblock(dp->index,0);

  while(hi>=lo)
  {
   i=(lo+hi)>>1;
   ii=loi+hii;
   if((ii & 1) && i) i-=(sizeof(index)>>1);
   ii=ii>>1;

   f=(index *)(p+i);

   code=xstrncmp(string,f->key,KEYLEN,flags);

   if(!code) break;
   else
   if(code>0) {lo=i+sizeof(index);loi=ii+1;}
   else       {hi=i-sizeof(index);hii=ii-1;}
  }

 
  while((code<=0) && (i>0))
  {
   i-=sizeof(index);
   ii--;
   f=(index *)(p+i);
   code=xstrncmp(string,f->key,KEYLEN,flags);
  }




  if((*flags) & 0x20000)                   /* fast search */
  {
   return(xscanword(string,flags,f->key,charblock(dp->words,WOFF(f))));
  }
  else  
  {
   strncpy(words->string,f->key,KEYLEN);
   words->woffset=WOFF(f);
   words->indexn=ii;
   words->wordn=WORDN(f);
   words->len=0;

   formword(dp,words);

   oldwords=*words;

   while(1)
   {
    code=xstrncmp(string,words->string,STRMAX,flags);
    if(!code)  return(1);
    if(code<0) break;
    oldwords=*words;
    if(!nextword(dp,words)) break;
   }

   *words=oldwords;
  }
 }
   
 return(0);
}






void testdict(dict * dp)
{
 int         n=dp->noindex;
 index    *  f;
 char     *  p;
 int         i;

  cprintf("noindex %d",n);

 for(i=0;i<n;i++)
 {
  f=(index*)charblock(dp->index,i*sizeof(index));
  p=charblock(dp->words,WOFF(f));
  if(*p>30)
  {
 //  cprintf("error index=%d f->key=%s f->woff=%d",i,f->key,WOFF(f));
     cprintf("code %d %d %d error index=%d f->woff=%d",*(p-1),*p,*(p+1),i,WOFF(f));
  }
 }
}





/* returns word structure for n'th word in dictionary */

int locword(int seekn,dict * dp,word * words)
{
 int         n=dp->noindex;
 int         lo=0;
 int         hi=(n-1)*sizeof(index);
 int         i=0;
 int         loi=0;
 int         hii=n-1;
 int         ii=0;
 index    *  f=NULL;


 if((unsigned int)seekn>=dp->nowords) return(0);

 while(hi>=lo)
 {
  i=(lo+hi)>>1;
  ii=loi+hii;
  if((ii & 1) && i) i-=sizeof(index)/2;
  ii=ii>>1;

  f=(index *)charblock(dp->index,i);

  if(WORDN(f)==(unsigned int)seekn) break;
  else
  if(WORDN(f)<(unsigned int)seekn)  {lo=i+sizeof(index);loi=ii+1;}
  else                              {hi=i-sizeof(index);hii=ii-1;}
 }
        

 if(WORDN(f)>(unsigned int)seekn)
 {
  i-=sizeof(index);
  ii--;
  f=(index *)charblock(dp->index,i);
 }

 strncpy(words->string,f->key,KEYLEN);
 words->woffset=WOFF(f);
 words->indexn=ii;
 words->wordn=WORDN(f);
 words->len=0;
 formword(dp,words);

 while(words->wordn<(unsigned int)seekn) nextword(dp,words);
 return(1);
}


/****************************************************************************/


/* delete a word from a dictionary */

int deleteword(char * string,dict * dp)
{
 word words;
 int  code;
 int  flags=0;

 code=findword(string,dp,&words,&flags);
 if(!code) return(0);             /* word was not in dictionary */
 code=remword(dp,&words);
 return(code);
}


/* add a word to a dictionary */

os_error * addword(char * string,dict * dp)
{
 os_error * err;
 int        code;
 word       words;
 int        flags=0;
 int        len=strlen(string);

 err=NULL;

 if(len && len<=STRMAX)
 {
  code=findword(string,dp,&words,&flags);
  while(code)                /* word was in dictionary */
  {
   if(strncmp(string,words.string,STRMAX))
   {
    deleteword(string,dp);
    code=findword(string,dp,&words,&flags);
   }
   else
   {
    break;
   }
  }

  if(!code)
  {
   err=storeword(string,dp,&words);
  }
 }

 return(err);
}



char * wordn(int n,dict * dp)
{
 static char string[STRLEN];
 int         code;
 word        words;

 code=locword(n,dp,&words);

 if(code) strcpy(string,words.string);
 else     strcpy(string,"");

 return(string);
}


int nowords(dict * dp)
{
 return(dp->nowords);
}


/*****************************************************************************/


/* clear dictionary structure */

void trashdc(dict * dp)
{
 if(dp->words) deleteblock(&dp->words);
 if(dp->index) deleteblock(&dp->index);
 dp->nowords=0;
 dp->noindex=0;
}



/* initialise dictionary structure */

void createdc(dict * dp)
{
 createblock(&dp->words,0);
 createblock(&dp->index,0);
 dp->nowords=0;
 dp->noindex=0;
}



static os_error * dopen(char * path,char * name,char mode,buffer* bf)
{
 char string[MAX_PATH];

 strcpy(string,path);
 strcat(string,"\\");
 strcat(string,name);
 strcat(string,".dic");

 cprintf("dopen %s",string);
 return(bf_open(string,mode,DEFBUFFSIZE,bf));
}


/* lo level load dictionary into dictionary structure */

os_error * loaddc(char * path,char * name,dict * dp)
{
 os_error * err;
 buffer     bf;
 dheader    dh;


 err=dopen(path,name,'r',&bf);
 if(!err)
 {
  trashdc(dp);

  err=bf_read(&bf,&dh,sizeof(dheader));
  if(!err)
  {
   if(strcmp(dh.mark,"1.00")<0) err=geterror(EDCOLD);
   if(dh.capabilities)          err=geterror(EDCAPS);
   if(!err) err=bf_geti(&bf,(int*)&dp->nowords);
   if(!err) err=bf_geti(&bf,(int*)&dp->noindex);
  
   if(!err) err=loadmemblock(&dp->words,&bf);
   if(!err) err=loadmemblock(&dp->index,&bf);
  }
  err=bf_close(&bf,err);
 }

 if(err)
 {
  dp->nowords=dp->noindex=0;
 }

 return(err);
}


/* lo level save dictionary strcuture */

os_error * savedc(char * path,char * name,dict * dp)
{
 os_error * err;
 buffer     bf;
 dheader    dh;

 memset(&dh,0,sizeof(dheader));

 strcpy(dh.name,"CrossStar Dictionary");
 strcpy(dh.mark,"1.00");
 strcpy(dh.copy,"(16-Mar-2002)");
 dh.capabilities=0;

 err=dopen(path,name,'w',&bf);
 if(!err)
 {
  bf_write(&bf,&dh,sizeof(dheader));
  bf_puti(&bf,dp->nowords);
  bf_puti(&bf,dp->noindex);
  savememblock(&dp->words,&bf);
  savememblock(&dp->index,&bf);
  err=bf_close(&bf,err);
 }

 return(err);
}






/*

void dctest(void)
{
 index indi;
 int   woffset;
 int   wordn;

 while(1)
 {
  printf("\ninput:");
  scanf("%d %d",&woffset,&wordn);

  SETWOFF(&indi,woffset);
  SETWORDN(&indi,wordn);

  printf("woffset=%d wordn=%d\n",woffset,wordn);

  woffset=WOFF(&indi);
  wordn=WORDN(&indi);

  printf("woffset=%d wordn=%d\n",woffset,wordn);

  SETWOFF(&indi,WOFF(&indi)+8);
  SETWORDN(&indi,WORDN(&indi)+8);


  woffset=WOFF(&indi);
  wordn=WORDN(&indi);


  printf("woffset=%d wordn=%d\n",woffset,wordn);

  printf("indexp.woffset=%d indexp.wordn=%d indi.extra=%x\n",
             indi.woffset,indi.wordn,indi.extra);


 }

}
*/




