/*->h.sp     */

/* maximum number of user dictionaries */
#define MAXNAMES 32


extern char  dcmap[MAXNAMES];            /* dictionaries for file      */
extern int   nodc;


typedef struct 
{
 char name[32];
 dict dictp;
 char uses;
 char loaded;
 char modded;
} dline;


extern dline dtable[MAXNAMES];



extern os_error * editdict(int m3);
extern os_error * initsp(void);
extern void   finitsp(void);
extern void   checkkey(int * key); 
extern int *  setdictm(int m3);
extern void   popsavedc(void);
extern void   checksword(char * string);
extern int    nodcs(void);
extern int    nodcsexhp(void); 
extern os_error * createdict(char * string);
extern os_error * loaddict(int m3);
extern os_error * deletedict(int m3);
extern os_error * deletedictsub(int m3);

extern os_error * dcaddload(int n);
extern int    finddc(char * name);

extern os_error * loaddcn(int n);
extern void   dccleanup(void);

extern int    totnames;

extern void   makeguess(char * string);

extern void   copyfhdc(int destfh,int srcfh);
extern int    readfhdc(FILE * fp);
extern int    writefhdc(FILE * fp);
extern void   mapfhdc(void);
extern void   newfhdcmap(void);
extern void   trashfhdc(void);

extern void   editdicon(void);
extern void   editdkey(int * key);

extern int    search(int clue);
extern char * swordn(int word);

extern os_error * anagramsearch(char * string);

extern int  wordsearch(char * string);
extern void randomwordstart(void);
extern void randomword(char * string);


extern os_error * checkfiledc(void);

extern os_error * spellcheck(void);

extern void savechanges(void);
extern void scrapchanges(void);
extern int  changes(void);
extern void checkcont(void);



